/*
 * CS 106X Fall 2018 - Nick Troccoli
 * Starter code for problems from Section #8 (Week 9)
 * Section topic: More graphs, inheritance and polymorphism
 */

#include <iostream>
#include <fstream>
#include "console.h"
#include "riggeddice.h"

using namespace std;

/**************************************************
 * 1-2. Kruskal's and topological sort - (graphs) *
 **************************************************/

// no code required for these problems; see solution handout


/**********************************************************************
 * 3. Inheritance and polymorphism trace - (inheritance/polymorphism) *
 **********************************************************************/
// class hierarchy as defined in the section handout:
class Lettuce {
public:
    virtual void m1() {
        cout << "L1" << endl;
        m2();
    }

    virtual void m2() {
        cout << "L2" << endl;
    }
};

class Bacon : public Lettuce {
public:
    virtual void m1() {
        Lettuce::m1();
        cout << "B1" << endl;
    }

    virtual void m3() {
        cout << "B3" << endl;
    }
};

class Hamburger : public Bacon {
public:
    virtual void m2() {
        cout << "H2" << endl;
        Bacon::m2();
    }

    virtual void m4() {
        cout << "H4" << endl;
    }
};

class Mayo : public Hamburger {
public:
    virtual void m3() {
        cout << "M3" << endl;
        m1();
    }

    virtual void m4() {
        cout << "M4" << endl;
    }
};

void runInheritanceTraces() {
    Lettuce* var1 = new Bacon();
    Bacon* var2 = new Mayo();
    Lettuce* var3 = new Hamburger();
    Bacon* var4 = new Hamburger();
    Lettuce* var5 = new Lettuce();

    /* Try out any function calls here!
     * Just make sure to work through them yourself, too. */
}

/*********************************
 * 4. RiggedDice - (inheritance) *
 *********************************/

// see RiggedDice.h and RiggedDice.cpp for this problem.


/* main function for testing individual problems */
int main() {
    cout << "Problem 3 (Inheritance and polymorphism trace):" << endl;
    runInheritanceTraces();

    cout << endl << "Problem 4 (Rigged Dice):" << endl;
    // Test your RiggedDice implementation here.

    return 0;
}
